// CvicnaHodina.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

/*
Napiste program, ktery deklaruje jednu celociselnou promennou pojemnovanou num.
Priradte teto promenne hodnotu 1000 a pak pomoci jednoho prikazu printf()
vypiste hodnotu num na obrazovku.
*/
void Vypis1000()
{
	int x = 1000;
	printf("%d\n", x);
}
//-------------------------------------------------------------------------

/*
Napiste program, ktery nacte dve desetinna cisla (pouzijte typ float) a pak
vytiskne jejich soucet
*/
void DveCisla()
{
	float x, y;
	printf("Zadej dve desetinna cisla\n");

	// Nez psat obe %f do jedne funkce je lepsi napsat je takto zvlast, protoze
	// scanf() nez nacte cislo preskakuje vsechny bile znaky. Takto dovolime
	// uzivateli, aby cisla napsal na jednu radku oddelene mezerou ci vice mezerami,
	// nebo aby treba napsal druhe cislo na samostatnou radku.
	// Kdybychom napsali scanf("%f %f", &x, &y), musel by uzivatel napsat cislo, pak
	// presne jednu mezeru a pak druhe cislo, jinak by to nefungovalo.
	scanf("%f", &x);
	scanf("%f", &y);

	printf("Soucet: %f\n", x+y);
}
//---------------------------------------------------------------------------

/*
Napiste program, ktery vypocita pocet sekund v roce
*/
void SekundyVRoce()
{
	// pocet sekund v minute * pocet minut v hodine * hodin ve dni * dni v roce
	printf("Pocet sekund v roce: %d\n", 60*60*24*365);
}

//---------------------------------------------------------------

/*
Napiste program, ktery pouziva funkci nazvanou convert(), ktera prevadi castku
v korunach na dolary (smenny kurs 24.50 Kc za dolar). Program vyzve uzivatele
k zadani castky v korunach a vypise kolik je to dolaru.
*/

// pokud chceme definici funkce napsat az za jeji volani, musime pred volanim
// aspon rici, jake parametry funkce ma a co vraci. To se provede takto:
float convert(float);
// Je to vlastne opsana hlavicka a misto tela funkce je strednik. Vsimete si, ze
// jmena parametru nejsou dulezita, musi se napsat akorat typy.

void PrevodNaDolary()
{
	float kc;
	printf("Zadej pocet korun:\n");
	scanf("%f", &kc);
	printf("Pocet dolaru: %f", convert(kc));
}

float convert(float kc)
{
	// zvolili jsme jako navratovou hodnotu float, kompilator ovsem ciselne konstanty
	// s desetinnou teckou v programu povazuje za typ double. Proto deleni
	// kc/24.5
	// chce delit float/double. Aby mohl pocitac deleni provest, musi mit obe cisla
	// stejny typ (plati i pro ostatni operace - nasobeni, scitani, modulo atd.)
	// Vzdy prevadi typ s mensim rozsahem na typ s vetsim rozsahem, tj. zde prevede
	// float kc na double. Vysledkem deleni je zase typ double a ten se ma vratit
	// v typu float, ktery je urcen jako navratovy typ funkce. Tedy by probehla
	// zase konverze zpet na float, to je ale zmensovani rozsahu cisla a neni zaruceno,
	// ze v double je ulozena hodnota, co se vejde do float. Proto kompilator zobrazi
	// warning "Possible loss of data". Aby konstantu kompilator povazoval za float,
	// deleni tedy pak provedl ve floatech a vysledkem byl float udelame tak, ze za
	// konstantu napiseme 'f', jak je udelano.
	return kc/24.5f;
}

//----------------------------------------------------------------

/*
Napiste program, ktery pouziva funkci nazvanou outnum(), ktera prebira jeden
celociselny argument a vypise jej na obrazovku.
*/
void outnum(int cislo)
{
	// tento kod se provede trikrat (funkce je zavolana trikrat), promenna
	// cislo bude obsahovat pokazde to cislo, ktere je uvedeno pri volani.
	printf("%d", cislo);
}

void VypisCisla()
{
	// zkusime trikrat vytisknout nejake cislo
	outnum(345);
	outnum(23);
	outnum(56);
}

//----------------------------------------------------------------

/*
Napiste program, ktery pozada uzivatele o zadani celeho cisla a pak uzivateli
rekne, zda je toto cislo sude nebo liche (pouzijte operator modulo %).
*/
void SudeNeboLiche()
{
	int x;
	printf("Napis cele cislo:");
	scanf("%d", &x);

	if (x%2 == 0) // zbytek po deleni cisla dvema je bud 0 nebo 1, nic jineho nenastava
		printf("Zadali jste sude cislo.\n"); // zbytek je 0, cili sude cislo
	else
		printf("Zadali jste liche cislo.\n"); // zbytek neni 0, cili je jedna a je
	                                        // to liche cislo
}

//---------------------------------------------------------

/*
Napiste program, ktery si vyzada dve cisla a pak zobrazi podle volby uzivatele bud
jejich soucet nebo soucin.
*/
void SoucetNeboSoucin()
{
	// Pokud nahradime v teto funkci float za double, nechodi to... (A nevim proc :))

	float x, y;
	printf("Zadej dve realna cisla: ");
	scanf("%f", &x); // precteme si jedno cislo
	scanf("%f", &y); // precteme druhe cislo, ale uzivatel musel minimalne odradkovat
	                 // nebo mohl za cislo na radku napsat jeste neco jineho, tyto
	                 // znaky ale uz scanf() neprecte a zustavaji cekat na vstupu

	int ch;
	do // precteme vsechno co zbyva na vstupu, aby se pri cteni + nebo * neprecetl
	{  // konec radky nebo jiny znak, co ceka na precteni. Vime, ze vstup od uzivatele
		 // skoncil odradkovanim, tedy cteme do te doby, dokud neprecteme konec radku '\n'.

		ch = getchar(); // musime pouzit getchar(), getch() nefunguje, protoze to cte
		                // znaky primo "z klavesnice", ani se neukazuji na obrazovce
		                // a neprochazeji nahrazenim dvojice znaku \r\n (coz pouzivaji
		                // Windows jako konec radky) za jediny znak \n.
	}
	while(ch != '\n'); // dokud neni v ch konec radku, pokracujeme.

	// mame cisla, ptame se, co budeme delat
	printf("Zvol nasobeni(*) nebo scitani(+): ");
	// precteme jeden znak, melo by to byt * nebo +
	int znak = getchar();

	if (znak == '*')
	{
		// bylo to *, nasobime
		printf("Soucin: %f\n", x*y);
	}
	else
	{
		// nebylo to *, predpokladame, ze je to + a  scitame. Spravnejsi by bylo
		// kontrolovat, zda uzivatel zadava skutecne jen + nebo * a pokud zada neco
		// jineho, tak se ho zeptat znovu.
		printf("Soucet: %f\n", x+y);
	}
	
}

//-----------------------------------------------------------------

/*
Napiste program, ktery vytiskne cisla mezi 17 a 100 vcetne, ktera lze delit
beze zbytku 17.
*/

// prvni verze - zbytecne pomala
void Delitelna17()
{
	for (int i = 17; i <= 100; i++) // cyklus prochazi VSECHNA cisla od 17 do 100
	{                               // a zkousi jejich delitelnost 17
		if (i%17 == 0)
			// pokud zbytek po deleni 17 je 0, je cislo delitelne 17 a vypiseme ho
			printf("%d ", i);
	}
}

// -------------------------------------------------------------

// druha verze - rychlejsi
void Delitelna17Podruhe()
{
	for (int i = 17; i <= 100; i += 17) // cyklus pricita rovnou 17 a tedy
	{                                   // jde jen po cislech delitelnych 17
		printf("%d ", i);                 // a ta vypisuje
	}

}

//-----------------------------------------------------------------

// treti verze - s vecnym cyklem
void Delitelna17Potreti()
{
	int i = 17; // zaciname na sedmnactce

	for (;;) // totez co while(true), nikdy cyklus neprerusi, je ho treba tedy prerusit
	{        // nekde uvnitr v tele prikazem break nebo return

		// k i pricteme 17, totez, co jsme delali ve druhe verzi v kroku for cyklu
		i += 17; // zkracena verze tohoto i = i + 17

		if (i > 100)
			break; // a pokud i preleze 100, skoncime

		// neskoncili jsme, tedy i je porad jeste <= 100 a vypiseme ho
		printf("%d ", i);
	}
}

//-----------------------------------------------------------------

// V tomto jednom souboru je hodne prikladu, kazdy je v samostatne funkci
// a to, ktery se zavola, je urceno tim, jake cislo se priradi do promenne
// priklad. Podle toho se ve switch konstruktu, ktery nasleduje, zavola
// spravna funkce.
int main()
{
	int priklad = 0;
	switch (priklad)
	{
	case 0: Vypis1000(); break;
	case 1: DveCisla(); break;
	case 2: SekundyVRoce(); break;
	case 3: PrevodNaDolary(); break;
	case 4: VypisCisla(); break;
	case 5: SudeNeboLiche(); break;
	case 6: SoucetNeboSoucin(); break;
	case 7: Delitelna17(); break;
	case 8: Delitelna17Podruhe(); break;
	case 9: Delitelna17Potreti(); break;
	}

	getch(); // spolecne cekani na klavesu pro vsechny priklady
	return 0;
}

//---------------------------------------------------
